#pragma once

#include "ofxWarp.h"

#include "particle.h"
#include "drawableImage.h"
#include "imageParticleSystem.h"
#include "rainParticleSystem.h"
#include "ofMain.h"
#include "particleSystem.h"
#include "avatar.h"
#include "ofxOsc.h"
#include "visitor.h"
#include "objectPhysics.h"
#include "particle.h"
#include "ofxOpenCv.h"
#include "ofTrueTypeFont.h"
#include "ofxCv.h"


//int WINDOWSIZE_WIDTH = 1000;
//int WINDOWSIZE_HEIGHT = 1000;




// *** SETUP OSC INFORMATION *** SETUP OSC INFORMATION ***

#define PORT 12345
#define HOST "xxx.xxx.xxx.xxx"




class ofApp : public ofBaseApp {

public:

	void setup();
	void update();
	void draw();
	void exit();
	void keyPressed(int key);
	void keyReleased(int key);
	void mouseMoved(int x, int y);
	void mouseDragged(int x, int y, int button);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);
	void mouseEntered(int x, int y);
	void mouseExited(int x, int y);
	void windowResized(int w, int h);
	void dragEvent(ofDragInfo dragInfo);
	void gotMessage(ofMessage msg);


	int PARTICLE_COUNT;
	//+1 for every new Particle, -1 for every Particle that gets older than the defined maxLife
	int VISITOR_COUNT;
	//the visitor count will be fed with the nBlobs-value from incoming OSC messages
	int VISITOR_COUNT_LASTFRAME;



private:

	// *** OSC *** OSC *** OSC ***

	string oscMsg;
	ofxOscReceiver receiver;
	float timeSent, timeReceived;


	//Information about what is going on in the scene

	int nBlobs;         //count of the tracked visitors

	// *** warp *** warp
	ofxWarpController warpController;
	ofTexture tex;
	ofRectangle area;
	ofVec2f sceneSize;
	ofVec2f force;

	ofImage img;
	ofImage fileImageHex;
	ofImage imageToDraw;

	ofImage drawImage;

	ofColor color;

	ofFbo fbo;

	vector<ofVec2f>attractors;
	vector<Particle*> system;

	vector<ImageParticleSystem*> imageParticleSystems;
	vector<RainParticleSystem*> rainParticleSyst;

	int currentImage;
	int maxParticle;
	int picPix;
	int k;
	int ticksToMoveParticlesToRight;
	int counterToMoveParticlesToRight;
	bool rainIsActive;
	bool editingWarp;





	vector<Visitor*> visitors;

	vector<ParticleSystem*> particleSystems;



};



